//=============================================================================

#ifndef HANOI_HPP
#define HANOI_HPP

#include <vector>

//-----------------------------------------------------------------------------

class Hanoi
{
public:
   using tower_t = std::vector<int>;

   Hanoi(int);

   void printGame();
   void run();

private:
   bool isIndexAllowed(int idx, const tower_t& tower);
   void printLevelOfTower(int level, const tower_t& tower);
   void printLevelOfAllTowers(int level);
   void printBasePlate();
   void moveSlice(tower_t& src, tower_t& dest);
   void moveTower(int size, tower_t& src, tower_t& dest, tower_t& util);

   tower_t tower1;
   tower_t tower2;
   tower_t tower3;

   int countSlices;
   int counter = 0;
};

//-----------------------------------------------------------------------------

#endif
