#include <iostream>
#include <limits>
#include "human.hpp"
using namespace std;

Move askHumanForMove(const TicTacToe& ttt)
{
   for (;;)
   {
      cout << "Lieber Mensch - welchen Zug moechtest du machen (1..9): ";
      int value;
      cin >> value;
      if (cin.fail())
      {
         cin.clear();
         cin.ignore(numeric_limits<streamsize>::max(), '\n');
         cout << "\nKeine Zahl => Neueingabe\n\n";
         continue;
      }
      if (value < 1 || value > 9)
      {
         cout << "\nKein gueltiger Feldindex => Neueingabe\n\n";
         continue;
      }

      // 1..9 => row 0..2 & col 0..2           (value-1)/3      (value-1)%3
      // 1        0          0                    0                    0
      // 2        0          1                    0                    1
      // 3        0          2                    0                    2
      // 4        1          0                    1                    0
      // 5        1          1                    1                    1
      // 6        1          2                    1                    2
      // 7        2          0                    2                    0
      // 8        2          1                    2                    1
      // 9        2          2                    2                    2
      const int row = (value - 1) / 3;
      const int col = (value - 1) % 3;
      if (ttt.isNotFree(row, col))
      {
         cout << "\nFeld ist schon belegt => Neueingabe\n\n";
         continue;
      }

      return Move(row, col, GameColor::white);
   }
}
