#ifndef TICTACTOE_HPP
#define TICTACTOE_HPP

#include <iostream>
#include <vector>
#include "move.hpp"

class TicTacToe
{
public:
   TicTacToe();

   friend std::ostream& operator<<(std::ostream&, const TicTacToe&);

   bool isNotFree(int row, int col) const;
   bool isFree(int row, int col) const { return !isNotFree(row, col); }

   void set(const Move&);

   bool hasWin(GameColor) const;

   bool isFull() const;

private:
   enum class State { empty, white, black };

   static State convert(GameColor);

   std::vector<std::vector<State>> mFields;
};

#endif
