//=============================================================================

#include <iostream>
#include <map>
#include <string>
using namespace std;

//-----------------------------------------------------------------------------

using db_t = map<string, string>;

//-----------------------------------------------------------------------------

db_t createDB()
{
   db_t db;
   db.insert({ "Lea", "1123" });
   db.insert({ "Max", "0257 / 88956" });
   db.insert({ "Eva", "888" });
   db.insert({ "Tom", "987" });
   db.insert({ "Det", "+49 030 / 45 56 89 56" });
   return db;
}

//-----------------------------------------------------------------------------

void printDB(const db_t& db)
{
   cout << db.size() << " Kontakte vorhanden:\n";
   for (auto& [name, no] : db)
   {
      cout << "- " << name << " => " << no << '\n';
   }
}

//-----------------------------------------------------------------------------

void searchInDB(const db_t& db, const string& pattern)
{
   cout << "Suche nach \"" << pattern << "\":\n";
   auto fit = db.find(pattern);
   if (fit == cend(db))
   {
      cout << pattern << " ist nicht in der Datenbank vorhanden\n";
      return;
   }
   cout << pattern << " => " << fit->second << '\n';
}

//-----------------------------------------------------------------------------

int main()
{
   cout << "WS 2024/25 - Telefonbuch 1\n\n";

   db_t db = createDB();
   for (string input;;)
   {
      cout << "\nEingabe: ";
      getline(cin, input);
      cout << '\n';

      if (input == "end")
      {
         break;
      }
      else if (input == "list")
      {
         printDB(db);
         continue;
      }
      searchInDB(db, input);
   }

   cout << "Programmende...\n\n";
}
